Attribute VB_Name = "Module1"
Option Explicit

Const vmax = 4, xmax = 4, ymax = 7, zmax = 4    'size of the grid

Public i As Integer, v As Integer, x As Integer, y As Integer, z As Integer 'temporary variables

'Grids
'Grid of fallen pieces, little extra space for rotation-checks
Public grid(-3 To 7, -3 To 7, -10 To 12, -3 To 7) As Byte
'Currently falling piece
Public falling(4, 4, 4, 4) As Byte
'Position of currently falling piece
Public fv As Integer, fx As Integer, fy As Integer, fz As Integer
'Temporary grid for rotation etc.
Public temp(-vmax To vmax * 2, -xmax To xmax * 2, -ymax To ymax * 2, -zmax To zmax * 2) As Byte

Public running As Boolean   'is the game currently running?
Public score As Long
Public mode As Byte '2=x,3=xz,4=vxz 'mode of line removal
Public rotatfalling As Byte 'rotate falling pieces?

Public Function LineMade() As Boolean 'check if a line is complete?
Select Case mode    'what mode are we in?
Case 2              '2d
LineMade = False

For v = 0 To vmax: For z = 0 To zmax: For y = 0 To ymax
For x = 0 To xmax
If grid(v, x, y, z) = 0 Then GoTo notfound
Next
GoTo found
notfound:
Next: Next: Next

Exit Function

found:
LineMade = True
For y = y To 1 Step -1
For x = 0 To xmax
grid(v, x, y, z) = grid(v, x, y - 1, z)
Next
Next

For x = 0 To xmax
grid(v, x, 0, z) = 0
Next

Case 3
LineMade = False

For v = 0 To vmax: For y = 0 To ymax
For z = 0 To zmax: For x = 0 To xmax
If grid(v, x, y, z) = 0 Then GoTo notfound2
Next: Next
GoTo found2
notfound2:
Next: Next

Exit Function

found2:
LineMade = True
For y = y To 1 Step -1
For z = 0 To zmax: For x = 0 To xmax
grid(v, x, y, z) = grid(v, x, y - 1, z)
Next: Next
Next

For x = 0 To xmax: For z = 0 To zmax
grid(v, x, 0, z) = 0
Next: Next

Case 4:
LineMade = False

For y = 0 To ymax
For v = 0 To vmax: For z = 0 To zmax: For x = 0 To xmax
If grid(v, x, y, z) = 0 Then GoTo notfound3
Next: Next: Next
GoTo found3
notfound3:
Next

Exit Function

found3:
LineMade = True
For y = y To 1 Step -1
For v = 0 To vmax: For z = 0 To zmax: For x = 0 To xmax
grid(v, x, y, z) = grid(v, x, y - 1, z)
Next: Next: Next
Next

For v = 0 To vmax: For x = 0 To xmax: For z = 0 To zmax
grid(v, x, 0, z) = 0
Next: Next: Next


End Select

DrawGrid
score = score + 5 * mode + y
NewScore
LineMade

End Function

Public Function Collision() As Boolean

Collision = False

For v = 0 To vmax
For x = 0 To xmax
For y = 0 To ymax
For z = 0 To zmax
    If grid(v, x, y, z) <> 0 And temp(v, x, y, z) <> 0 Then Collision = True
Next: Next: Next: Next

End Function
Public Function Collisionb() As Boolean

Collisionb = False

For v = 0 To 3
For x = 0 To 3
For y = 0 To 3
For z = 0 To 3
    If grid(v + fv, x + fx, y + fy, z + fz) <> 0 And temp(v, x, y, z) <> 0 Then Collisionb = True
Next: Next: Next: Next

End Function

Public Function MoveFalling(dv As Integer, dx As Integer, dy As Integer, dz As Integer) As Boolean
Dim MaxV, MaxX, MaxY, MaxZ
Dim MinV, MinX, MinY, MinZ
MinV = vmax: MinX = xmax: MinY = ymax: MinZ = zmax
MaxV = 0: MaxX = 0: MaxY = 0: MaxZ = 0

MoveFalling = False

For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    If falling(v, x, y, z) <> 0 Then
       If MaxV < v Then MaxV = v
       If MaxX < x Then MaxX = x
       If MaxY < y Then MaxY = y
       If MaxZ < z Then MaxZ = z
       
       If MinV > v Then MinV = v
       If MinX > x Then MinX = x
       If MinY > y Then MinY = y
       If MinZ > z Then MinZ = z
    End If
Next: Next: Next: Next

'some bug occurred, falling piece seems to be blank
If MaxV = 0 And MaxX = 0 And MaxY = 0 And MaxZ = 0 And MinV = 4 And MinX = 4 And MinY = 4 And MinZ = 4 Then
EmptyFalling
NewFalling
End If

If MaxV + dv + fv > vmax Then Exit Function
If MaxX + dx + fx > xmax Then Exit Function
If MaxZ + dz + fz > zmax Then Exit Function
If MinV + dv + fv < 0 Then Exit Function
If MinX + dx + fx < 0 Then Exit Function
If MinZ + dz + fz < 0 Then Exit Function

EmptyTemp
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    temp(v + dv + fv, x + dx + fx, y + dy + fy, z + dz + fz) = falling(v, x, y, z)
Next: Next: Next: Next

If Collision Or MaxY + dy + fy > ymax Then
    
    If MinY + dy + fy <= 0 And dy > 0 Then
        GameOver
    ElseIf dy > 0 Then
        FallingToGrid
        LineMade
    End If
    Exit Function
End If

fv = fv + dv
fx = fx + dx
fy = fy + dy
fz = fz + dz

MoveFalling = True
End Function
Public Function CheckBoundaries() As Boolean
Dim MaxV, MaxX, MaxY, MaxZ
Dim MinV, MinX, MinY, MinZ
MinV = vmax: MinX = xmax: MinY = ymax: MinZ = zmax
MaxV = 0: MaxX = 0: MaxY = 0: MaxZ = 0

CheckBoundaries = False
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    If temp(v, x, y, z) <> 0 Then
       If MaxV < v Then MaxV = v
       If MaxX < x Then MaxX = x
       If MaxY < y Then MaxY = y
       If MaxZ < z Then MaxZ = z
       
       If MinV > v Then MinV = v
       If MinX > x Then MinX = x
       If MinY > y Then MinY = y
       If MinZ > z Then MinZ = z
    End If
Next: Next: Next: Next

If MaxV + fv > vmax Then Exit Function
If MaxX + fx > xmax Then Exit Function
If MaxY + fy > ymax Then Exit Function
If MaxZ + fz > zmax Then Exit Function
If MinV + fv < 0 Then Exit Function
If MinX + fx < 0 Then Exit Function
If MinZ + fz < 0 Then Exit Function
'If MinY + fy < 0 Then Exit Function


CheckBoundaries = True

End Function
Public Sub FallingToTemp()
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    temp(v + fv, x + fx, y + fy, z + fz) = falling(v, x, y, z)
Next: Next: Next: Next
End Sub
Public Sub TempToFalling()
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    falling(v, x, y, z) = temp(v, x, y, z)
Next: Next: Next: Next
End Sub
Public Sub EmptyFalling()
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    falling(v, x, y, z) = 0
Next: Next: Next: Next
End Sub
Public Sub EmptyTemp()
For v = 0 To vmax: For x = 0 To xmax: For y = 0 To ymax: For z = 0 To zmax
    temp(v, x, y, z) = 0
Next: Next: Next: Next
End Sub

Public Sub DrawGrid()
Dim Index, color
If running = False Then Exit Sub

For Index = 0 To 24
    v = Index Mod 5
    z = Int(Index / 5)
    For x = 0 To xmax: For y = 0 To ymax
        color = grid(v, x, y, z)
        frmGame.picArea(Index).Line (x, y)-(x + 1, y + 1), QBColor(color), BF
    Next: Next
    
    For x = 0 To 3: For y = 0 To 3
        If v - fv >= 0 And v - fv <= 3 Then
        If z - fz >= 0 And z - fz <= 3 Then
            color = falling(v - fv, x, y, z - fz)
            If color > 0 Then frmGame.picArea(Index).Line (x + fx, y + fy)-(x + fx + 1, y + fy + 1), QBColor(color + 8), BF
        End If: End If
    Next: Next
    
    For x = 0 To xmax
        frmGame.picArea(Index).Line (x, 0)-(x, ymax + 1), 0
    Next
    For y = 0 To ymax
        frmGame.picArea(Index).Line (0, y)-(xmax + 1, y), 0
    Next
Next

End Sub

Public Sub FallingToGrid()
For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
    If falling(v, x, y, z) <> 0 Then grid(v + fv, x + fx, y + fy, z + fz) = falling(v, x, y, z)
Next: Next: Next: Next
EmptyFalling
NewFalling
DrawGrid
End Sub
Public Sub RotateFallingZ(direction) '1 = right, -1 = left
Select Case direction
Case 1
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, 3 - y, x, z) = falling(v, x, y, z)
    Next: Next: Next: Next
Case -1
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, y, 3 - x, z) = falling(v, x, y, z)
    Next: Next: Next: Next
End Select

If Not CheckBoundaries Or Collisionb Then Exit Sub
TempToFalling
DrawGrid
End Sub
Public Sub RotateFallingX(direction) '1 = right, -1 = left
Select Case direction
Case 1
    'y0123z
    '0-x--
    '1-x--
    '2-x--
    '3----
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, z, x, 3 - y) = falling(v, x, y, z)
    Next: Next: Next: Next
Case -1
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, 3 - z, x, y) = falling(v, x, y, z)
    Next: Next: Next: Next
End Select

If Not CheckBoundaries Or Collisionb Then Exit Sub
TempToFalling
DrawGrid
End Sub
Public Sub RotateFallingY(direction) '1 = right, -1 = left
Select Case direction
Case 1
    'x0123z
    '0-x--
    '1-x--
    '2-x--
    '3----
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, y, 3 - z, x) = falling(v, x, y, z)
    Next: Next: Next: Next
Case -1
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(v, y, z, 3 - x) = falling(v, x, y, z)
    Next: Next: Next: Next
End Select

If Not CheckBoundaries Or Collisionb Then Exit Sub
TempToFalling
DrawGrid
End Sub
Public Sub RotateFallingV(direction) '1 = right, -1 = left
Select Case direction
Case 1
    'v0123z
    '0-x--
    '1-x--
    '2-x--
    '3----
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(3 - z, y, x, v) = falling(v, x, y, z)
    Next: Next: Next: Next
Case -1
    For v = 0 To 3: For x = 0 To 3: For y = 0 To 3: For z = 0 To 3
        temp(z, y, x, 3 - v) = falling(v, x, y, z)
    Next: Next: Next: Next
End Select

If Not CheckBoundaries Or Collisionb Then Exit Sub
TempToFalling
DrawGrid
End Sub
Public Sub NewFalling()
fy = -2
fx = Int(Rnd * 2) + 1
fz = Int(Rnd * 2) + 1
fv = Int(Rnd * 2) + 1
Dim color As Integer, piece As Integer

color = Int(Rnd * 4) + 1

'-x-- -x-- --x- --x- -x-- -x-- ----
'-x-- -x-- --x- -xx- -xx- -xx- -xx-
'-x-- -xx- -xx- -x-- --x- -x-- -xx-
'-x-- ---- ---- ---- ---- ---- ----
piece = Int(Rnd * 7)
Select Case piece
Case 0
    falling(1, 1, 0, 1) = color
    falling(1, 1, 1, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 1, 3, 1) = color
Case 1
    falling(1, 1, 1, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 1, 3, 1) = color
    falling(1, 2, 3, 1) = color
Case 2
    falling(1, 2, 1, 1) = color
    falling(1, 2, 2, 1) = color
    falling(1, 2, 3, 1) = color
    falling(1, 1, 3, 1) = color
Case 3
    falling(1, 2, 1, 1) = color
    falling(1, 2, 2, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 1, 3, 1) = color
Case 4
    falling(1, 1, 1, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 2, 2, 1) = color
    falling(1, 2, 3, 1) = color
Case 5
    falling(1, 1, 1, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 1, 3, 1) = color
    falling(1, 2, 2, 1) = color
Case Else
    falling(1, 1, 1, 1) = color
    falling(1, 1, 2, 1) = color
    falling(1, 2, 1, 1) = color
    falling(1, 2, 2, 1) = color
End Select
Select Case rotatfalling
Case 2
    For i = 0 To 10
        RotateFallingZ Int(Rnd * 3) - 1
    Next
Case 3
    For i = 0 To 10
        RotateFallingZ Int(Rnd * 3) - 1
        RotateFallingX Int(Rnd * 3) - 1
        RotateFallingY Int(Rnd * 3) - 1
    Next
End Select
End Sub
Public Sub GameOver()
Dim i, timeh, ib
frmGame.tmrFalling.Enabled = False
running = False

For ib = 0 To 4
For y = 0 To ymax
For i = 0 To 4
frmGame.picArea(i + ib * 5).Line (0, y)-(xmax + 1, y + 1), 0, BF
Next
timeh = Timer + ((ymax * 5) - (y + ib * 5)) * 0.001
Do
DoEvents
Loop Until timeh <= Timer
Next
Next

End Sub
Public Sub RandomGrid(lines As Integer)
For v = 0 To vmax: For x = 0 To xmax: For y = (ymax - lines + 1) To ymax: For z = 0 To zmax
    grid(v, x, y, z) = Int(Rnd * 5)
Next: Next: Next: Next
LineMade
score = 0
NewScore
End Sub
Public Sub NewScore()
frmGame.lblScore.Caption = Right("000000" + Str(score), 7)
End Sub
